///+X================================================================X+
//+X===               ,    .
//+X===                                                
//+X================================================================X+
//+------------------------------------------------------------------+
//|                                   !!!!0_ABC_Kassandra-ver4-5m.mq4 |
//|                                          Copyright  2011, Segun |
//|                                  http://www.segun1966.hmsite.net |
//+------------------------------------------------------------------+
//+X================================================================X+
//+X================================================================X+
//+X===  Copyright  Mariusz Woloszyn,KimIV,Roch,I_D,Yuriy Tokman,
//+X===  Nazariy S.(WWer),Joo,XEON,Nikolay Kositsin,Vinin and many others                                            
//+X================================================================X+
#property copyright "Copyright  2011, Segun"
#property link      "http://www.segun1966.hmsite.net"
//+X================================================================X+
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
static datetime sdtPrevtime = 0;
//+X================================================================X+
#import "stdlib.ex4"
string ErrorDescription(int error_code);
int    RGB(int red_value,int green_value,int blue_value);
bool   CompareDoubles(double number1,double number2);
string DoubleToStrMorePrecision(double number,int precision);
string IntegerToHexString(int integer_number);
//+X================================================================X+
#import "kernel32.dll"
void GetLocalTime(int& TimeArray[]);
void GetSystemTime(int& TimeArray[]);
int  GetTimeZoneInformation(int& TZInfoArray[]);
int CopyFileA (string lpExistingFileName,string lpNewFileName,int bFailIfExists);
//+X================================================================X+
#import "user32.dll"
int RegisterWindowMessageA(string lpstring);
int PostMessageA( int hWnd, int Msg, int wParam, string lParam );
//+X================================================================X+
//---- errors returned from trade server
#define ERR_NO_ERROR                                  0
#define ERR_NO_RESULT                                 1
#define ERR_COMMON_ERROR                              2
#define ERR_INVALID_TRADE_PARAMETERS                  3
#define ERR_SERVER_BUSY                               4
#define ERR_OLD_VERSION                               5
#define ERR_NO_CONNECTION                             6
#define ERR_NOT_ENOUGH_RIGHTS                         7
#define ERR_TOO_FREQUENT_REQUESTS                     8
#define ERR_MALFUNCTIONAL_TRADE                       9
#define ERR_ACCOUNT_DISABLED                         64
#define ERR_INVALID_ACCOUNT                          65
#define ERR_TRADE_TIMEOUT                           128
#define ERR_INVALID_PRICE                           129
#define ERR_INVALID_STOPS                           130
#define ERR_INVALID_TRADE_VOLUME                    131
#define ERR_MARKET_CLOSED                           132
#define ERR_TRADE_DISABLED                          133
#define ERR_NOT_ENOUGH_MONEY                        134
#define ERR_PRICE_CHANGED                           135
#define ERR_OFF_QUOTES                              136
#define ERR_BROKER_BUSY                             137
#define ERR_REQUOTE                                 138
#define ERR_ORDER_LOCKED                            139
#define ERR_LONG_POSITIONS_ONLY_ALLOWED             140
#define ERR_TOO_MANY_REQUESTS                       141
#define ERR_TRADE_MODIFY_DENIED                     145
#define ERR_TRADE_CONTEXT_BUSY                      146
#define ERR_TRADE_EXPIRATION_DENIED                 147
#define ERR_TRADE_TOO_MANY_ORDERS                   148
#define ERR_TRADE_HEDGE_PROHIBITED                  149
#define ERR_TRADE_PROHIBITED_BY_FIFO                150
//---- mql4 run time errors
#define ERR_NO_MQLERROR                            4000
#define ERR_WRONG_FUNCTION_POINTER                 4001
#define ERR_ARRAY_INDEX_OUT_OF_RANGE               4002
#define ERR_NO_MEMORY_FOR_CALL_STACK               4003
#define ERR_RECURSIVE_STACK_OVERFLOW               4004
#define ERR_NOT_ENOUGH_STACK_FOR_PARAM             4005
#define ERR_NO_MEMORY_FOR_PARAM_STRING             4006
#define ERR_NO_MEMORY_FOR_TEMP_STRING              4007
#define ERR_NOT_INITIALIZED_STRING                 4008
#define ERR_NOT_INITIALIZED_ARRAYSTRING            4009
#define ERR_NO_MEMORY_FOR_ARRAYSTRING              4010
#define ERR_TOO_LONG_STRING                        4011
#define ERR_REMAINDER_FROM_ZERO_DIVIDE             4012
#define ERR_ZERO_DIVIDE                            4013
#define ERR_UNKNOWN_COMMAND                        4014
#define ERR_WRONG_JUMP                             4015
#define ERR_NOT_INITIALIZED_ARRAY                  4016
#define ERR_DLL_CALLS_NOT_ALLOWED                  4017
#define ERR_CANNOT_LOAD_LIBRARY                    4018
#define ERR_CANNOT_CALL_FUNCTION                   4019
#define ERR_EXTERNAL_CALLS_NOT_ALLOWED             4020
#define ERR_NO_MEMORY_FOR_RETURNED_STR             4021
#define ERR_SYSTEM_BUSY                            4022
#define ERR_INVALID_FUNCTION_PARAMSCNT             4050
#define ERR_INVALID_FUNCTION_PARAMVALUE            4051
#define ERR_STRING_FUNCTION_INTERNAL               4052
#define ERR_SOME_ARRAY_ERROR                       4053
#define ERR_INCORRECT_SERIESARRAY_USING            4054
#define ERR_CUSTOM_INDICATOR_ERROR                 4055
#define ERR_INCOMPATIBLE_ARRAYS                    4056
#define ERR_GLOBAL_VARIABLES_PROCESSING            4057
#define ERR_GLOBAL_VARIABLE_NOT_FOUND              4058
#define ERR_FUNC_NOT_ALLOWED_IN_TESTING            4059
#define ERR_FUNCTION_NOT_CONFIRMED                 4060
#define ERR_SEND_MAIL_ERROR                        4061
#define ERR_STRING_PARAMETER_EXPECTED              4062
#define ERR_INTEGER_PARAMETER_EXPECTED             4063
#define ERR_DOUBLE_PARAMETER_EXPECTED              4064
#define ERR_ARRAY_AS_PARAMETER_EXPECTED            4065
#define ERR_HISTORY_WILL_UPDATED                   4066
#define ERR_TRADE_ERROR                            4067
#define ERR_END_OF_FILE                            4099
#define ERR_SOME_FILE_ERROR                        4100
#define ERR_WRONG_FILE_NAME                        4101
#define ERR_TOO_MANY_OPENED_FILES                  4102
#define ERR_CANNOT_OPEN_FILE                       4103
#define ERR_INCOMPATIBLE_FILEACCESS                4104
#define ERR_NO_ORDER_SELECTED                      4105
#define ERR_UNKNOWN_SYMBOL                         4106
#define ERR_INVALID_PRICE_PARAM                    4107
#define ERR_INVALID_TICKET                         4108
#define ERR_TRADE_NOT_ALLOWED                      4109
#define ERR_LONGS_NOT_ALLOWED                      4110
#define ERR_SHORTS_NOT_ALLOWED                     4111
#define ERR_OBJECT_ALREADY_EXISTS                  4200
#define ERR_UNKNOWN_OBJECT_PROPERTY                4201
#define ERR_OBJECT_DOES_NOT_EXIST                  4202
#define ERR_UNKNOWN_OBJECT_TYPE                    4203
#define ERR_NO_OBJECT_NAME                         4204
#define ERR_OBJECT_COORDINATES_ERROR               4205
#define ERR_NO_SPECIFIED_SUBWINDOW                 4206
#define ERR_SOME_OBJECT_ERROR                      4207
//+------------------------------------------------------------------+
#define  RESCANSERVERS_COMMAND_CODE   37400
#define  OPENLOGINWINDOW_COMMAND_CODE 35429
#define  PAUSE 1000
//+X================================================================X+
#import "Block_err_130.ex4"
  double ND(double v);  string OrderError(); 
  int Tip=-1,iTicket=0,spread;
  double OPos=0,SLpos=0,TPpos=0,Closepos=0,point;            
//+------------------------------------------------------------------+
//-----      ------
int M, TypeOrder;double OP, StopLoss,TakeProfit, NewOpenPrice, NewStopLoss, NewTakeProfit;
//+X================================================================X+
//+X================================================================X+
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
//---- input parameters
 bool      UseBatteruortSimple=true;
 int FLFPeriod=2, K=4; double BSNow,BSPrev,BSPred;
//----
 bool      UseBubbleAndDrops=true;
 int historyDeep=100;      //    
 int future=24;            //     
   double BDNow, BDPrev,BDPrev2, BDPred;
//----
extern bool      UseFuture=true;
 int      PastBars            = 34;
 int      ForBars             = 24;
 int      PeriodMA            = 12;
extern bool     IsExactTime         = true;
 int      nFutBar             = 22;// Should be less than ForBars
 int      nPoints             = 13;
double            fHi, fLo, bTP;
//----
double SL=0.0,TP=0.0;double stdPoint   = 0.0001;string SYMBL = "";
#define UpSigBuffNumber  0
#define DnSigBuffNumber  1
#define IndBarsCnt       3
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
extern bool      CheckForClose=true;
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
extern bool      UsePerceptron=true;
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
//+X================================================================X+
//+X================================================================X+
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
extern bool    UseSimpleNeuro=false;
extern double  x0 =  10 ; 
extern double  x1 =  10 ;
extern double  x2 =  10 ;
extern double  x3 =  10 ; 
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
extern bool      FiltrStoch     = true;   //   
extern bool      BatteruortFiltre = true; //     
//+X================================================================X+
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
extern bool      UseTakeProfit=false;
extern bool      UseStaticTakeProfit=true;
extern int       StaticTakeProfit=22;
extern bool      UseStopLoss=false;
extern bool      UseStaticStopLoss=false;
extern int       StaticStopLoss=30;
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
extern int    MagicNumber       = 233585;
 int    ProfitFactor      = 2;
 int    StopLossFactor    = 1;
 int    AccountOrders     = 3; 
 int    Distance          = 5;        
 bool   BarsControl       = true;
extern bool   Reverse           = false;
//+X================================================================X+
extern bool   FixedLot          = false;
extern bool   UseMultyKLot      = false;
extern double Lots              = 0.1;
extern double MultyKLot         = 1.0;
extern double MaximumRisk       = 0.9;
extern double DecreaseFactor    = 0;
//+X================================================================X+
extern bool UseTrailing      = true;        //   
extern bool ProfitTrailing   = true;        //   
extern bool   Trailing          = true;     //  
extern int    MinProfit         = 5;
extern int    TrailingStop      = 5;
extern int  TrailingStopBuy  = 13;          //   
extern int  TrailingStopSell = 13;          //   
extern int  TrailingStep     = 4;           //  
extern double SaveZone=4;                   //    KillLoss
extern int    Slippage          = 3;
//+X================================================================X+
extern bool   NoLoss            = true;
extern int    MinProfitB        = 5;
extern int    NoLossLevel       = 5;
//+X================================================================X+
 int    Shift              = 0;
//+X================================================================X+
extern bool   TradeOnFriday      =  true; int BeginTradeHour = 0, EndTradeHour  = 0;
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
//---- input parameters
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
#define OP_BALANCE 6
#define NONE 0
double            UpSig, DnSig;
//+X================================================================X+
//---- input parameters
//+X================================================================X+
string TradesFileName="TradeStat.csv"; 
int StatBars; int stat_FileHandle;
//----   
 int  TradeDay                   = 0; 
 bool ReversDay                  = false;
//----   
 bool ReversTradeSignal          = false;
//----    
 bool TradeSignalEveryTick       = false;
 int  TradeSignalBarPeriod       = 60;//     ( )
 int  CloseSignalBarPeriod       = 90;//    ( )
//+X================================================================X+
//-------    -------------------------------------+
bool   gbDisabled   = False;           //   
bool   gbNoInit     = False;           //   
color  clModifyBuy  = Aqua;            //    
color  clModifySell = Tomato;          //    
 bool   UseSound     = False;          //   
 int    NumberOfTry  = 2;             //   
//+X~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~X+
//+X================================================================X+
// Global variables
//+X================================================================X+
string day,val[8];int Order_Count[6];string   ds_SYM = "", gs_Comment = "",
         gs_ComError = "",          //    
         gs_ICNameGV;               //  GV-
static double stochLevel20=23.0, stochLevel50=50.0, stochLevel80=77.0;
double StoPrev,SignalPrev,StoNow,SignalNow,StoPrev2,SignalPrev2, StoNow2,SignalNow2;
double SpearmanNow , SpearmanPrev, SpearmanPred;               
 int  count=2; //----  ArraySize()
 string Complex, SymbolName [];double nPoint = 0.0001;
 double MDVNow=0.0, MDVPrev=0.0, PointUSD=0.0, PriceBuy=0.0, PriceSell=0.0, PriceOpen=0.0;
      int Roll_upUp=0,Roll_upDown=0,Roll_upStop=10,MA_Period=34,AtrPeriod=20;
 int MA_Metod=MODE_SMA;
double  max =0; double  min =0; double N_Turtles=0;
double    Inc0 = 0.0000; double    Inc1 = 0.0000;
double    Inc2 = 0.0000; double    Inc3 = 0.0000;
#define Pi 3.14159
int Start,i,m;
double Gamma,alfa,b,ci,g,MA[5000],Y[5000]; double DV[];
double B1[];double B2[];double R2[];
double multiply;int    PriceInt[];int    SortInt[];
 bool SMOOTH=true; double       N=20,
  SmoothPower=0; //  
 int  CalculatedBars = 0; int  Maxrange = 30; bool direction = true; 
//----
int BarsCount = 15000000;
//----
double OrderPrevProfit, OrderPrevLot, OrderPrevSL, OrderPrevTP;
int OrderPrevTicket, OrderPrevType;
 int PauseBeforeTrade = 10; //     ( )
int    Timeframe_Up = 60;int    Timeframe_Dn = 60;
//       
int pre_OrdersArray[][2]; // [ ][ ,  ]
//  
int eventBuyClosed_SL  = 0, eventBuyClosed_TP  = 0;
int eventSellClosed_SL = 0, eventSellClosed_TP = 0;
int eventBuyLimitDeleted_Exp  = 0, eventBuyStopDeleted_Exp  = 0;
int eventSellLimitDeleted_Exp = 0, eventSellStopDeleted_Exp = 0;
int eventBuyLimitOpened  = 0, eventBuyStopOpened  = 0;
int eventSellLimitOpened = 0, eventSellStopOpened = 0;
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
int buyOrders = 0, sellOrders = 0, allOrders = 0; 
string DivTrainStr = "; ";
// Long position ticket
int LongTicket = -1;
// Short position ticket
int ShortTicket = -1;
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
int CountBuyOrders = 0, CountSellOrders = 0;
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define  MAX_TC                   8    //    
#define  Trend_UP                 0    //    TraillingProfit
#define  Trend_DW                 1    //    TraillingProfit
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
double        gda_Price[2],               //   
              // gda_Price[0] - Bid
              // gda_Price[1] - Ask
              gda_TC.SL[MAX_TC],
              gda_TC.TP[MAX_TC],
              gda_TC.TS[MAX_TC],
              gda_TC.lot[MAX_TC],
              gd_Point, /*gd_MaxLot, gd_MinLot, gd_StepLot*/
              gd_Profit,
              gd_XFactor;
int           gia_TC.Magic[MAX_TC],
              gia_TC.Enable[MAX_TC],
              gia_TC.PeriodRating[MAX_TC],
              gia_TC.Var.TS[MAX_TC],
              gia_TC.Var.STOP[MAX_TC],
              gia_TC.Orders[MAX_TC],      //       
              gia_PerceptronBars[5],
              gia_DirectionBars[4],
              gi_MyOrders,                //      
              gi_flag_TP,                 //  Traiiling Profit
              gi_flag_NullStop,           //   
              gi_LastTrend = -1,          //   
              gi_Decimal = 1, gi_Digits, gi_dig = 0;
string        gs_Symbol, gs_NameGV, gs_trade, gs_TradeCom[3], gs_VirtCom[3];
bool          gba_TC.OnlyBU[MAX_TC];
datetime      NewBar, gdta_CommTime[7];
//+X================================================================X+
double GetStdPointSize(string SMBL)
{
    // ********************** FOREX ********************** 
    if (StringFind(SMBL, "JPY") != -1) return(0.01);
    if (StringFind(SMBL, "HUF") != -1) return(0.01);
    if (StringFind(SMBL, "XAG") != -1) return(0.01);
    if (StringFind(SMBL, "XAU") != -1) return(0.1);
    if (StringFind(SMBL, "USD") != -1) return(0.0001);
    // ********************** CFD ********************** 
    return(0.01);
}
//+X================================================================X+       
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
//+X================================================================X+       
//+------------------------------------------------------------------+
int TradeSignal (int workPeriod)
   {
//+------------------------------------------------------------------+
   bool res=OP_BALANCE;int i; int closePeriod=Period();
   bool resStohastic=OP_BALANCE,  resIndicator=OP_BALANCE, 
   BUY_Sign = false, BUY_Stop = false, SELL_Sign = false,  SELL_Stop = false;           
   workPeriod=Period();
//+------------------------------------------------------------------+
//            workPeriod)
//+------------------------------------------------------------------+
   if (SaveZone<MarketInfo(Symbol(),MODE_SPREAD))  SaveZone=MarketInfo(Symbol(),MODE_SPREAD);
   SaveZone=SaveZone*Point;
//+------------------------------------------------------------------+
///--- Now -   , Prev - , Pred -  
//+------------------------------------------------------------------+
   StoNow=iStochastic(Symbol(),workPeriod,13,3,5,MODE_SMA,0,MODE_MAIN,0);
   SignalNow=iStochastic(Symbol(),workPeriod,13,3,5,MODE_SMA,0,MODE_SIGNAL,0);
   StoPrev=iStochastic(Symbol(),workPeriod,13,3,5,MODE_SMA,0,MODE_MAIN,1);
   SignalPrev=iStochastic(Symbol(),workPeriod,13,3,5,MODE_SMA,0,MODE_SIGNAL,1);
//+------------------------------------------------------------------+
   BSNow=NormalizeDouble(iCustom(Symbol(),workPeriod,"!0_ABC_BS",FLFPeriod,K,0,0),Digits);
   BSPrev=NormalizeDouble(iCustom(Symbol(),workPeriod,"!0_ABC_BS",FLFPeriod,K,0,1),Digits);
   BSPred=NormalizeDouble(iCustom(Symbol(),workPeriod,"!0_ABC_BS",FLFPeriod,K,0,2),Digits);
//+------------------------------------------------------------------+
   BDNow=NormalizeDouble(iCustom(Symbol(),workPeriod,"!0_AMM_BubbleAndDrops",historyDeep,future,1,0),Digits);
   BDPrev=NormalizeDouble(iCustom(Symbol(),workPeriod,"!0_AMM_BubbleAndDrops",historyDeep,future,0,-1),Digits);
   BDPrev2=NormalizeDouble(iCustom(Symbol(),workPeriod,"!0_AMM_BubbleAndDrops",historyDeep,future,0,-2),Digits);
   BDPred=NormalizeDouble(iCustom(Symbol(),workPeriod,"!0_AMM_BubbleAndDrops",historyDeep,future,1,1),Digits);
//+------------------------------------------------------------------+
   fHi = iCustom(NULL, 0, "Future", PastBars, ForBars, PeriodMA, IsExactTime, 0, nFutBar);
   fLo = iCustom(NULL, 0, "Future", PastBars, ForBars, PeriodMA, IsExactTime, 1, nFutBar);      
//+------------------------------------------------------------------+

//+--------- 

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~      
         //---- SELL conditions----------                  
         if (
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            ((UseBatteruortSimple) && (BSNow < BSPrev &&  BSPrev > BSPred)) ||
            ((UseBubbleAndDrops) && (BDNow < BDPrev &&  BDNow > BDPred && BDPrev2 < BDPrev)) ||
            ((UseFuture) && (fHi < (Close[0] - nPoints * Point)  && fLo < (Close[0] - nPoints * Point) )) 
                               
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
           )//if     
          resIndicator=OP_SELL;//
//+------------------------------------------------------------------+
         //---- BUY conditions----------                  
         if (
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            ((UseBatteruortSimple) && (BSNow > BSPrev &&  BSPrev < BSPred))  ||
            ((UseBubbleAndDrops) && (BDNow > BDPrev &&  BDNow < BDPred && BDPrev2 > BDPrev)) ||
            ((UseFuture) && (fHi > (Close[0] + nPoints * Point) && fLo > (Close[0] + nPoints * Point) )) 
                                
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
           )//if     
          resIndicator=OP_BUY; // 
//+------------------------------------------------------------------+
          else resIndicator=OP_BALANCE;          
           //---- 

//+------------------------------------------------------------------+
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
//~~~~    -     - -   
 if (FiltrStoch)
 {
        if (StoNow<stochLevel20)
          {          if (resIndicator==OP_SELL) res=OP_BALANCE;}
          if (StoNow>stochLevel80)
          {          if (resIndicator==OP_BUY)  res=OP_BALANCE;}
                   if (StoNow>stochLevel20)
          {if (resIndicator==OP_SELL)  res=resIndicator;}
          if (StoNow<stochLevel80)
          {if (resIndicator==OP_BUY)   res=resIndicator;}
 }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
   res=resIndicator;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
//~~~~
   return (res);   
   }  
//+X================================================================X+
//+X================================================================X+
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void StartMessage()
   {
//----
   int i=0;
   string currString="";
   string array[5];
//----
   array[0]=StringConcatenate(" ",WindowExpertName(),"   :");
   if (TradeSignalEveryTick)
      array[1]="1)    ; ";
   else              
      array[1]=StringConcatenate("1)        ",Period()," ;");
   if (TradeDay==0)   //    
      array[2]="2)   ; ";
   else       {
      if (ReversDay) //      
         array[2]=StringConcatenate("2)   ,    ",TradeDay);
      else           //       
         array[2]=StringConcatenate("2)      ",TradeDay);
      }
   for ( i=0;i<5;i++) currString=StringConcatenate(currString,"\n",array[i]);
   Comment(currString);
   for (i=2;i>=0;i--) Print(array[i]);   
//----
   }
//+X================================================================X+     
//+X================================================================X+
//+------------------------------------------------------------------+
//|      ,        |
//+------------------------------------------------------------------+
int getCorrectTimeFrame(int period)
   {
   int res=period;
//----
   switch (period)
      {
      case PERIOD_MN1:  break;  //  ,   
      case PERIOD_W1:  break;  //  ,   
      case PERIOD_D1:  break;  //  ,   
      case PERIOD_H4:  break;  //  ,   
      case PERIOD_H1:  break;  //  ,   
      case PERIOD_M30: break;  //  ,   
      case PERIOD_M15: break;  //  ,   
      case PERIOD_M5:  break;  //  ,   
      case PERIOD_M1:  break;  //  ,   
      default: res=Period();   //  ,   
      }
//----
   return(res);      
   }
//+X================================================================X+
//+X================================================================X+
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init ()
{      
//------------
    nPoint   = GetStdPointSize(Symbol());
    SYMBL    = Symbol();
    stdPoint = GetStdPointSize(SYMBL);
    if (Digits == 5 ||Digits == 3) {
       Slippage = Slippage * 10;       Distance = Distance * 10;       MinProfit =  MinProfit * 10;
       TrailingStop =  TrailingStop * 10;       TrailingStep = TrailingStep * 10;
       MinProfitB = MinProfitB * 10;       NoLossLevel = NoLossLevel * 10;
       //----      
   TradeSignalBarPeriod=getCorrectTimeFrame(TradeSignalBarPeriod);
   CloseSignalBarPeriod=getCorrectTimeFrame(CloseSignalBarPeriod);       
   if(!IsOptimization()) StartMessage(); //   
//------------  .  
  if(!IsExpertEnabled())//  
   {Alert("!    **");}
   else 
   {Comment("   ,   .");}  
   return(0);
    }
//----
      spread=MarketInfo(Symbol(),MODE_SPREAD);point=MarketInfo(Symbol(),MODE_POINT);
      CreateLabel("copyright1","2011 @ Segun",DarkBlue,10,30,3,10);    
//----
    return (0);
}
//+X================================================================X+
//+X================================================================X+                                
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit ()
{
   if (IsTesting() || IsTradeAllowed()) PrintAllOrdersToFile();            
return (0);
}
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+X================================================================X+
//+X================================================================X+
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//| expert start function                                            |
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+ 
//+X================================================================X+       
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
int start ()
{
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
   int i, TradeSignal, CloseSignal; 
    bool BuySignal = false;    bool SellSignal = false;
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
  int hwnd = WindowHandle(Symbol(), Period());
  int MT4InternalMsg = RegisterWindowMessageA("MetaTrader4_Internal_Message");  
  //   
  PostMessageA(hwnd, MT4InternalMsg, 16, "");
//+X================================================================X+
   if (UseTrailing)    TrailingPositions();//----     
   if(Trailing) TrailPositions();          //----     
   if(NoLoss) CreateNoLoss();              //----   
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   130
   Block_err_130(M,TypeOrder,OP,StopLoss,TakeProfit,NewOpenPrice,NewStopLoss,NewTakeProfit); 
//+X================================================================X+
//----           
if (DayOfWeek( )==0) day="";
if (DayOfWeek( )==1) day="";
if (DayOfWeek( )==2) day="";
if (DayOfWeek( )==3) day="";
if (DayOfWeek( )==4) day="";
if (DayOfWeek( )==5) day="";
if (DayOfWeek( )==6) day="";
string info=StringConcatenate
(AccountCompany(),",  ",WindowExpertName(),".  : ",AccountNumber(),
",  :  ",AccountCurrency(),".  =",DoubleToStr(Lots,2));
string poems=StringConcatenate
(
"\n","       ,",
"\n","      .",
"\n","  ,      - ",
"\n","   ,  !"
);
string poems1=StringConcatenate
(
"\n","    ,   ,",
"\n","   ,   ",
"\n","     -   ",
"\n","   -   !"
);
if (AccountMargin()!=0) 
Comment (info,"\n"," ~~~~~~~~~~~~~~  Who Dares Wings ~~~~~~~~~~~~~~~~~~~~ ",
"\n",Hour(),":00. ",Day(),".",Month(),".",Year(),". ",day,"\n","=",
AccountBalance(),"\n","=",AccountEquity(),"\n","=",
NormalizeDouble((AccountBalance()-AccountEquity())/AccountBalance(),2)*100,"%",
"\n","Lot=",GetAmountLotFromOpenPos(),"\n"," =",OrdersTotal(),
"\n","   = ",AccountFreeMargin(),
"\n","    ,    .",
"\n","                             .      ","\n",poems1);
else 
Comment (info,"\n"," ~~~~~~~~~~~~~~  Who Dares Wings ~~~~~~~~~~~~~~~~~~~~ ",
"\n",Hour(),":00. ",Day(),".",Month(),".",Year(),". ",day,"\n","=",
AccountBalance(),"\n","=",AccountEquity(),"\n",
"=",NormalizeDouble((AccountBalance()-AccountEquity())/AccountBalance(),2),
"\n","Lot=",GetAmountLotFromOpenPos(),
"\n"," =",OrdersTotal(),"\n"," =0",
"\n","Don*t trouble troubles till troubles trouble you.","\n",poems);
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//+X================================================================X+
   if(Bars < 100 || IsTradeAllowed() == false) return;
   GetCurrentOrders(Symbol());
   if (AccountFreeMargin() > 0)
   double Lot;      bool   tradeAllow = false;
   if (BarsControl)
      if(Volume[0] > 1) return;
   if (!TradeOnFriday)
      if (DayOfWeek() == 5) return;
   if (BeginTradeHour > 0 && EndTradeHour > 0) {
      if (Hour() >= BeginTradeHour || Hour() <= EndTradeHour) tradeAllow = true;
   } else {
      tradeAllow = true;
   }
 //+X================================================================X+
  if (allOrders < AccountOrders || !AccountOrders && tradeAllow) {
         Lot = GetLotSize();  
         double MaxLot = MarketInfo(Symbol(), MODE_MINLOT);
         double MinLot = MarketInfo(Symbol(), MODE_MAXLOT); 
         double LotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
         double LockLot;
         double atr, TakeProfit, StopLoss;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   -  
         double SpreadPoints = MarketInfo(Symbol(), MODE_SPREAD) + 30;
//----
         if (UseTakeProfit)            {
            if (UseFuture)              TakeProfit = (fHi + fLo) / 2;
            if (TakeProfit < SpreadPoints) TakeProfit = 2*SpreadPoints;} 
         else
         {if (UseStaticTakeProfit) TakeProfit = StaticTakeProfit;}
         {if (!UseStaticTakeProfit && (!UseTakeProfit)) TakeProfit = 0;}
//----
         if (UseStopLoss)              {
            if (StopLoss < SpreadPoints) StopLoss = SpreadPoints;}
                  else
         {if (UseStaticStopLoss) StopLoss = StaticStopLoss;}
         {if (!UseStaticStopLoss && (!UseStopLoss)) StopLoss = 0;} 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
             if (UseSimpleNeuro)
             {
               UsePerceptron=true; 
               if (TradeSignal(Period()) == OP_BUY && Perceptron(Time[1])<0)  TradeSignal = OP_BUY;
               if (TradeSignal(Period()) == OP_SELL && Perceptron(Time[1])>0) TradeSignal = OP_SELL;           
             }
             else          TradeSignal = TradeSignal(Period());
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
             if (Reverse)
             {
             if  (TradeSignal(Period()) == OP_BUY) TradeSignal = OP_SELL;
             if  (TradeSignal(Period()) == OP_SELL) TradeSignal = OP_BUY;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~             TakeProfit = StopLoss; StopLoss = TakeProfit ;
             }
             else          TradeSignal = TradeSignal(Period());
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    ( )
            if (UseMultyKLot)
            {
            Lot = GetLotSize()*MultyKLot;
            }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   ,    
         //---- buy signal
         if (TradeSignal == OP_BUY) {
            if ( buyOrders < 1) {
                  LongTicket = OrderSend(Symbol(), OP_BUY, Lot, NormalizeDouble(Ask, Digits), Slippage,
                   0, 0, WindowExpertName()+Period(), MagicNumber, 0, Crimson);
                  if (LongTicket > 0) {
                        OrderModify(LongTicket, Lot, NormalizeDouble(Ask-(StopLoss*Point), Digits),
                         NormalizeDouble(Ask+(TakeProfit*Point),Digits), 0);
                                 if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}
                     }                                                    
            }         
         }
         else {            //&& buyOrders < 2
               if (IsOrderLock()) {
                    LongTicket = OrderSend(Symbol(), OP_BUY, Lot, NormalizeDouble(Ask, Digits),
                     Slippage, 0, 0, WindowExpertName()+Period(), MagicNumber, 0, Crimson);                   
                    if (LongTicket > 0) {   
                        OrderModify(LongTicket, LockLot, NormalizeDouble(Ask-(StopLoss*Point), Digits),
                         NormalizeDouble(Ask+(TakeProfit*Point), Digits), 0);
                                 if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}
                    }
               } else {                  //if (AccountFreeMargin() > 0) {
                     OrderSelect(LongTicket, SELECT_BY_TICKET);               
                     if ((MathAbs(OrderOpenPrice() - Ask) / Point) >=  Distance)                     
                        if (TradeSignal == OP_BUY) {   
                              LongTicket = OrderSend(Symbol(), OP_BUY, Lot, NormalizeDouble(Ask, Digits),
                               Slippage, 0, 0, WindowExpertName()+Period(), MagicNumber, 0, Crimson);                                 
                              if (LongTicket > 0) {
                                 OrderModify(LongTicket, Lot, NormalizeDouble(Ask-(StopLoss*Point), Digits),
                                  NormalizeDouble(Ask+(TakeProfit*Point), Digits), 0);
                                          if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}                           
                              }
                        }           
               }// else
         }// else 
          //--------------- sell signal -----------------
          if (TradeSignal == OP_SELL) {
            if(sellOrders < 1) {
                 ShortTicket = OrderSend(Symbol(),OP_SELL, Lot, NormalizeDouble(Bid, Digits),
                  Slippage, 0, 0, WindowExpertName()+Period(), MagicNumber, 0, DarkBlue);                   
                 if (ShortTicket > 0) {
                     OrderModify(ShortTicket, Lot, NormalizeDouble(Bid+(StopLoss*Point),Digits), 
                     NormalizeDouble(Bid-(TakeProfit*Point), Digits), 0);
                             if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}
                 }
            }
          }
          else {            //&& sellOrders < 2
                  if (IsOrderLock() ) {
                    ShortTicket = OrderSend(Symbol(),OP_SELL, Lot, NormalizeDouble(Bid, Digits),
                    Slippage, 0, 0, WindowExpertName()+Period(), MagicNumber, 0, DarkBlue);                      
                    if (ShortTicket > 0) {
                        OrderModify(ShortTicket, LockLot, NormalizeDouble(Bid+(StopLoss*Point),Digits),
                         NormalizeDouble(Bid-(TakeProfit*Point), Digits), 0);
                                 if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}
                        //sellOrders++;
                    }
               } else {                  //if (AccountFreeMargin() > 0) {                                                             
                     if ((MathAbs(OrderOpenPrice() - Bid) / Point) >=  Distance)
                        if(TradeSignal == OP_SELL) {                                             
                             ShortTicket = OrderSend(Symbol(),OP_SELL, Lot, NormalizeDouble(Bid, Digits),
                             Slippage, 0, 0, WindowExpertName()+Period(), MagicNumber, 0, DarkBlue);                            
                             if (ShortTicket > 0) {   
                                 //sellOrders++;
                             }
                        }
                } //else
          }// else
      }    //----
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   ,    
      if (CheckForClose)
      {
       if(TradeSignal == OP_SELL) CloseSignal =  OP_BUY ; 
       if(TradeSignal == OP_BUY)  CloseSignal = OP_SELL; 
       ClosePositions (Symbol(),CloseSignal,-1);  
      }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      CheckEvents(0);
    HistoryCalculate();
//+------------------------------------------------------------------+
//----
   return(0);
  }
//+X================================================================X+
///+X================================================================X+       
//-------~~~~~~~=========##### End expert start function #####=========~~~~~~~-------+
//+X================================================================X+
///+X================================================================X+       
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//-------~~~~~~~=========##### User`s library function #####=========~~~~~~~-------+    
//+X================================================================X+
///+X================================================================X+       
double Perceptron(datetime t_start=0)
{
//+------------------------------------------------------------------+
    double  x0 =  10 ; double  x1 =  10 ; double  x2 =  10 ; double  x3 =  10 ; 
   int shift=iBarShift(Symbol(),Period(),t_start,true);
   if(shift==-1)  {
      Print("  : "+TimeToStr(t_start,TIME_DATE|TIME_MINUTES));
      return(0);
   }  
   double bar[7];   int cnt=0;   double HL,LO,LC; 
   for(int i=shift;i<=shift+3;i++)  {
      double h=iHigh(Symbol(),Period(),i);      double l=iLow(Symbol(),Period(),i);
      double o=iOpen(Symbol(),Period(),i);      double c=iClose(Symbol(),Period(),i);
      HL=h-l;
      if(HL==0)HL=PointX();
      LO=o-l;
      LC=c-l;
      bar[cnt]=0.5*(LO/HL+LC/HL);      
      cnt++;           
   }
   double w0=x0-100.0;   double w1=x1-100.0;   double w2=x2-100.0;   double w3=x3-100.0;
   return(w0*bar[0] + w1*bar[1] + w2*bar[2] + w3*bar[3]);     
}
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
double PointX(string sy="0")   {
   if(sy=="0")sy=Symbol(); 
   int      dg=MarketInfo(sy,MODE_DIGITS);
   double   _return=0.0,
            po=MarketInfo(sy,MODE_POINT);
   if(dg==5||dg==3) _return=po*10;
   else  _return=po;
 return(_return);
}
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+X================================================================X+
void CreateLabel(string name, string txt, color clr, int x, int y,int corner,int FontSize)  {
  if (ObjectFind(name)<0) ObjectCreate(name, OBJ_LABEL, 0, 0,0);
  ObjectSetText(name, txt, FontSize);
  ObjectSet(name, OBJPROP_COLOR    , clr);
  ObjectSet(name, OBJPROP_XDISTANCE, x);
  ObjectSet(name, OBJPROP_YDISTANCE, y);
  ObjectSet(name, OBJPROP_CORNER   , corner);
  ObjectSet(name, OBJPROP_FONTSIZE , FontSize);
}       
//+X================================================================X+
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//-------~~~~~~~=========#####   #####=========~~~~~~~-------+  
//+----------------------------------------------------------------------------+
//|                                           |
//|  :                                                                |
//|    sy -     ("" -  )                   |
//|    op -                    (-1 -  )                    |
//|    mn - MagicNumber                (-1 -  )                      |
//+----------------------------------------------------------------------------+
void TrailingPositions(string sy="", int op=-1, int mn=-1) {
  double p, pp;
  int    i, k=OrdersTotal();
 color clModifyBuy=Red;
 color clModifySell=Blue;
  if (sy=="") sy=Symbol();
  p=MarketInfo(sy, MODE_POINT);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          if (OrderType()==OP_BUY) {
            pp=MarketInfo(sy, MODE_BID);
            if (!ProfitTrailing || (pp-OrderOpenPrice())>TrailingStopBuy*p) {
              if (OrderStopLoss()<pp-(TrailingStopBuy+TrailingStep-1)*p) {
                ModifyOrder(sy, -1, pp-TrailingStopBuy*p, 0, clModifyBuy);
              }            }          }
          if (OrderType()==OP_SELL) {
            pp=MarketInfo(sy, MODE_ASK);
            if (!ProfitTrailing || OrderOpenPrice()-pp>TrailingStopSell*p) {
     if (OrderStopLoss()>pp+(TrailingStopSell+TrailingStep-1)*p || OrderStopLoss()==0) {
                ModifyOrder(sy, -1, pp+TrailingStopSell*p, 0, clModifySell);
              }            }          }        }      }    }  }}
//+----------------------------------------------------------------------------+
//+X================================================================X+
//+----------------------------------------------------------------------------+
//|                                      |
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
	switch (op) {
		case OP_BUY      : return("Buy");
		case OP_SELL     : return("Sell");
		case OP_BUYLIMIT : return("Buy Limit");
		case OP_SELLLIMIT: return("Sell Limit");
		case OP_BUYSTOP  : return("Buy Stop");
		case OP_SELLSTOP : return("Sell Stop");
		default          : return("Unknown Operation");
	}
}
//+X================================================================X+
//+----------------------------------------------------------------------------+
//|                                                           |
//|  :                                                                |
//|    sy -    ("" -  )                    |
//|    pp -   ,                              |
//|    sl -                                                 |
//|    tp -                                                 |
//|    cl -                                                                |
//+----------------------------------------------------------------------------+
void ModifyOrder(string sy="", double pp=-1, double sl=0, double tp=0, color cl=CLR_NONE) {
  if (sy=="") sy=Symbol();
  bool   fm; int PauseAfterError=5;
  double pAsk=MarketInfo(sy, MODE_ASK);  double pBid=MarketInfo(sy, MODE_BID);
  int    dg, err, it, NumberOfTry=OrdersTotal();
  if (pp<=0) pp=OrderOpenPrice();
  if (sl==0) sl=OrderStopLoss();
  if (tp==0) tp=OrderTakeProfit();
  dg=MarketInfo(sy, MODE_DIGITS);
  pp=NormalizeDouble(pp, dg);  sl=NormalizeDouble(sl, dg);  tp=NormalizeDouble(tp, dg);
  if (pp!=OrderOpenPrice() || sl!=OrderStopLoss() || tp!=OrderTakeProfit()) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
      if (fm) {
         break;
      } else {
        err=GetLastError();
        Print("Error(",err,") modifying order: ",ErrorDescription(err),", try ",it);
        Print("Ask=",pAsk,"  Bid=",pBid,"  sy=",sy,"  op="+GetNameOP(OrderType()),
              "  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*PauseAfterError);        
        if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}
      }    }  }}
//+----------------------------------------------------------------------------+  
//+X================================================================X+
//------------------------------------------------------------------
// Get open positions                                         |
//------------------------------------------------------------------
int GetCurrentOrders(string symbol)
  {
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
   int i = 0;         
   buyOrders = 0;   sellOrders = 0;   allOrders = OrdersTotal();
   for(i=0; i < allOrders; i++)
     {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
        {
         if(OrderType() == OP_BUY) buyOrders++;
         if(OrderType() == OP_SELL) sellOrders++;
        }
     }
   return;
  }
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//------------------------------------------------------------------
// Calculate optimal lot size                                       
//------------------------------------------------------------------
double GetLotSize()
  {
   if (!FixedLot) {
      double lot = Lots;
      int    orders = HistoryTotal();     // history orders total
      int    losses = 0;                  // number of losses orders without a break    
      lot = NormalizeDouble(AccountFreeMargin()*MaximumRisk /(MarketInfo(Symbol(), MODE_LOTSIZE)/10), 2);    
   } else {
      lot = Lots;
   }
      if(DecreaseFactor>0) {
         for(int i = orders-1; i >= 0; i--)
           {
            if(OrderSelect(i, SELECT_BY_POS,MODE_HISTORY) == false) { Print("Error in history!"); break; }
            if(OrderSymbol() != Symbol() || OrderType() > OP_SELL) continue;
            //----
            if(OrderProfit() > 0) break;
            if(OrderProfit() < 0) losses++;
           }
         if(losses>1) lot = NormalizeDouble(lot-lot*losses/DecreaseFactor, 2);
        }
      double MinLot = MarketInfo(Symbol(), MODE_MINLOT);
      double MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);
      if (MinLot == 0) MinLot = 0.1;
      if (MaxLot == 0) MaxLot = 10000;
      if (lot < MinLot) lot = MinLot;
      if (lot > MaxLot) lot = MaxLot;
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
  }
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
bool IsOrderLock() {
      if (LongTicket > 0 && AccountFreeMargin() > 0) {
         OrderSelect(OrderTicket(), SELECT_BY_TICKET);
         OrderPrevProfit = OrderProfit();
         OrderPrevTicket = OrderTicket();
         OrderPrevLot = OrderLots();
         OrderPrevSL = OrderStopLoss();
         OrderPrevTP = OrderTakeProfit();
         OrderPrevType = OrderType();
         if  ( OrderPrevProfit < 0 && 
         (OrderPrevType == OP_BUY &&  MathAbs((OrderOpenPrice() - Ask) / Point) >= Distance) ||
         (OrderPrevType == OP_SELL  &&  MathAbs((OrderOpenPrice() - Bid)/Point) >= Distance)
          ) {            
            return (true);
         } 
         return (false);   
      }     
}
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//------------------------------------------------------------------
//  Trail positions 
//------------------------------------------------------------------
void TrailPositions()
{
  int orders = OrdersTotal();  
  for (int i=0; i<orders; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue;
    {    
      if (OrderType() == OP_BUY) {
        if (Bid-OrderOpenPrice() > MinProfit * Point)  {
          if (OrderStopLoss() < Bid-(TrailingStop+TrailingStep-1) * Point)  {
          OrderModify(OrderTicket(), OrderOpenPrice(), NormalizeDouble(Bid-TrailingStop * Point, Digits),
           OrderTakeProfit(), 0, Gold);
                   if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}          
          }
        }
      }  
      if (OrderType() == OP_SELL) {
        if (OrderOpenPrice()-Ask > MinProfit * Point) {
          if (OrderStopLoss() > Ask+(TrailingStop+TrailingStep-1) * Point) {
          OrderModify(OrderTicket(),OrderOpenPrice(), NormalizeDouble(Ask+TrailingStop * Point, Digits),
           OrderTakeProfit(), 0, Gold);
                   if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}         
          }
        }
      }   
    }   
  }  
}
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//------------------------------------------------------------------
// No Losee 
//------------------------------------------------------------------
void CreateNoLoss()
{
  int orders = OrdersTotal();
  for (int i=0; i<orders; i++)
  {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue;
    {    
      if (OrderType() == OP_BUY && OrderStopLoss() < OrderOpenPrice()) {
        if (Bid-OrderOpenPrice() > MinProfitB*Point) {
          if (OrderStopLoss() < Bid-(NoLossLevel-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + 
          NoLossLevel * Point, OrderTakeProfit(), 0, Magenta);
                  if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}           
          }
        }
      }
      if (OrderType() == OP_BUY && OrderStopLoss() == 0) {
        if (Bid-OrderOpenPrice() > MinProfitB * Point) {
          if (OrderStopLoss() < Bid-(NoLossLevel-1) * Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + 
          NoLossLevel * Point, OrderTakeProfit(), 0, Magenta);
                  if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}          
          }
        }
      }         
      if (OrderType() == OP_SELL && OrderStopLoss() > OrderOpenPrice())  
      {
        if (OrderOpenPrice()-Ask > MinProfitB*Point) {
          if (OrderStopLoss() > Ask+(NoLossLevel-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - 
          NoLossLevel * Point, OrderTakeProfit(), 0, Gold);
                  if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}           
          }
        }
      }  
      if (OrderType() == OP_SELL && OrderStopLoss() == 0) {
        if (OrderOpenPrice()-Ask > MinProfitB * Point) {
          if (OrderStopLoss() > Ask+(NoLossLevel-1) * Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(),OrderOpenPrice() - 
          NoLossLevel * Point, OrderTakeProfit(), 0, Gold);
                  if(Block_err_130(3,Tip,OPos,SLpos,TPpos,OPos,OPos,TPpos))
         {if(!OrderModify(iTicket,OPos,OPos,TPpos,0,Blue))
          {Alert("    ",GetLastError());
           Print("     ",
              OrderTicket(),". : ",GetLastError());Sleep(3000);}}           
          }
        }        
      }   
    }   
  }  
 }
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+X================================================================X+
//+------------------------------------------------------------------+
//|                                                             |
//+------------------------------------------------------------------+
void HistoryCalculate()
   {
   int historyTrades;
   int cancelledOrders;
   int cnt,i,znak,res,pos1,pos2;
   string curComment;
   for (cnt=HistoryTotal()-1;cnt>=0;cnt--)
      {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))
         {
         if (OrderType()>OP_SELL) cancelledOrders++; else historyTrades++;
         } 
      }
   double trades[][11];//  
   // 0 -    // 1 -   $   // 2 -      // 3 -   $/
   // 4 -      // 5 -     // 6 -      // 7 -    
   // 8 -       // 9 -     // 10    // 11    // 12  
   string commentsTrades[][3];
   double cancells[][6]; //  
   // 0 -    // 1 -      // 2 -  
   // 3 -     // 4 -     // 5 -    
   ArrayResize(trades,historyTrades);
   ArrayResize(commentsTrades,historyTrades);
   ArrayResize(cancells,cancelledOrders);
   stat_FileHandle=FileOpen(TradesFileName,FILE_WRITE | FILE_CSV,";");
   if (stat_FileHandle<1)
      {
      Print("   ,  ",ErrorDescription(GetLastError()));
      return;
      }   
   cnt=0;
   //   
   if(stat_FileHandle>0) res=FileWrite(stat_FileHandle,"ticket","Profit,$",
      "Profit,point","$/lot","Open Hour","Close Hour","Open Day",
      "Close Day","Hold Time","Comment","TP or SL","Order Type");
   for (i=0;i<HistoryTotal();i++)
      {
      if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
         {
         //Print("      ",i);
         if (OrderType()<=OP_SELL)
            {
            trades[cnt][0]=OrderTicket();
            trades[cnt][1]=OrderProfit();
            if (OrderType()==OP_BUY) znak=1; else znak=-1;
            trades[cnt][2]=NormalizeDouble((OrderClosePrice()-OrderOpenPrice())/Point*znak,0);
            //Print("Profit in points",trades[cnt][2]);
            trades[cnt][3]=trades[i][1]/(OrderLots()/0.1);
            trades[cnt][4]=TimeHour(OrderOpenTime());
            trades[cnt][5]=TimeHour(OrderCloseTime());
            trades[cnt][6]=TimeDayOfWeek(OrderOpenTime());
            trades[cnt][7]=TimeDayOfWeek(OrderCloseTime());
            trades[cnt][8]=(OrderCloseTime()-OrderOpenTime())/60;
            trades[cnt][9]=1;
            trades[cnt][10]=1;
            curComment=OrderComment();
            pos1=StringFind(curComment,"[tp]");
            if (pos1!=-1)
               {
               commentsTrades[cnt][0]=StringSubstr(curComment,0,pos1);
               commentsTrades[cnt][1]="[tp]";
               }
            pos2=StringFind(curComment,"[sl]");
            if (pos2!=-1)
               {
               commentsTrades[cnt][0]=StringSubstr(curComment,0,pos2);
               commentsTrades[cnt][1]="[sl]";
               }
            if (pos1==-1&&pos2==-1)
               {
               commentsTrades[cnt][0]=curComment;
               commentsTrades[cnt][1]="";
               }
            //Print("curComment=",curComment,"  pos1=",pos1,"  pos2=",pos2);
            if (OrderType()==OP_BUY) commentsTrades[cnt][2]="buy"; else commentsTrades[cnt][2]="sell";
            //Print("    ",trades[cnt][0]);
            if(stat_FileHandle>0) res=FileWrite(stat_FileHandle,trades[cnt][0],trades[cnt][1],
               trades[cnt][2],trades[cnt][3],trades[cnt][4],trades[cnt][5],trades[cnt][6],
               trades[cnt][7],trades[cnt][8],commentsTrades[cnt][0],commentsTrades[cnt][1],
               commentsTrades[cnt][2]);
            if (res<0) Print("     ",ErrorDescription(GetLastError()));  
            cnt++;
            }
         }// if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
      }// for (i=0;i<OrdersTotal();i++)
   FileClose(stat_FileHandle);
   return;
   }
//~~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~~~~~~~~~~~
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+---------       ----------------+
void CheckEvents( int magic = 0 )
{		static bool first = true;//   
	int _GetLastError = 0;	//   
	int _OrdersTotal = OrdersTotal();	//   
	// - ,   (    MagicNumber),
	//    
	int now_OrdersTotal = 0;
	// - ,  ,    
	static int pre_OrdersTotal = 0;
	//       
	int now_OrdersArray[][2]; // [  ][ ,  ]
	int now_CurOrder = 0;	//      now_OrdersArray ( )
	int pre_CurOrder = 0;	//      pre_OrdersArray ( )
	//        
	int now_ClosedOrdersArray[6][3]; // [ ][ ]
	//       
	int now_OpenedPendingOrders[4]; // [ ]
	bool OrderClosed = true, PendingOrderOpened = false;	//  
	int ticket = 0, type = -1, close_type = -1;	//  
	//  
	eventBuyClosed_SL  = 0; eventBuyClosed_TP  = 0;
	eventSellClosed_SL = 0; eventSellClosed_TP = 0;
	eventBuyLimitDeleted_Exp  = 0; eventBuyStopDeleted_Exp  = 0;
	eventSellLimitDeleted_Exp = 0; eventSellStopDeleted_Exp = 0;
	eventBuyLimitOpened  = 0; eventBuyStopOpened  = 0;
	eventSellLimitOpened = 0; eventSellStopOpened = 0;
	//        -
	ArrayResize( now_OrdersArray, MathMax( _OrdersTotal, 1 ) );
	//  
	ArrayInitialize( now_OrdersArray, 0.0 );
	//       
	ArrayInitialize( now_ClosedOrdersArray, 0.0 );
	ArrayInitialize( now_OpenedPendingOrders, 0.0 );
	//+------------------------------------------------------------------+
	//|         , 
	//|  
	//+------------------------------------------------------------------+
	for ( int z = _OrdersTotal - 1; z >= 0; z -- )
	{
		if ( !OrderSelect( z, SELECT_BY_POS ) )
		{
			_GetLastError = GetLastError();
			Print( "OrderSelect( ", z, ", SELECT_BY_POS ) - Error #", _GetLastError );
			continue;
		}
		//          MagicNumber
		if ( OrderMagicNumber() == magic && OrderSymbol() == Symbol() )
		{
			now_OrdersArray[now_OrdersTotal][0] = OrderTicket();
			now_OrdersArray[now_OrdersTotal][1] = OrderType();
			now_OrdersTotal ++;
		}
	}
	//       - ,  
	ArrayResize( now_OrdersArray, MathMax( now_OrdersTotal, 1 ) );
	//+------------------------------------------------------------------+
	//|     ,  ,    
	//|   
	//+------------------------------------------------------------------+
	for ( pre_CurOrder = 0; pre_CurOrder < pre_OrdersTotal; pre_CurOrder ++ )
	{	//     
		ticket = pre_OrdersArray[pre_CurOrder][0];
		type   = pre_OrdersArray[pre_CurOrder][1];
		OrderClosed = true;		// ,    ,   
		PendingOrderOpened = false;		// ,      ,    
		//        
		for ( now_CurOrder = 0; now_CurOrder < now_OrdersTotal; now_CurOrder ++ )
		{	//        ,
			if ( ticket == now_OrdersArray[now_CurOrder][0] )
			{	//      (   )
				OrderClosed = false;
				//    ,
				if ( type != now_OrdersArray[now_CurOrder][1] )
				{	//     ,   
					PendingOrderOpened = true;
				}
				break;
			}
		}
		//     ( ),
		if ( OrderClosed )
		{	if ( !OrderSelect( ticket, SELECT_BY_TICKET ) )//  
			{
				_GetLastError = GetLastError();
				Print( "OrderSelect( ", ticket, ", SELECT_BY_TICKET ) - Error #", _GetLastError );
				continue;
			}
			//  ,    ( ):
			if ( type < 2 )
			{	//   : 0 - , 1 - , 2 - 
				close_type = 0;
				if ( StringFind( OrderComment(), "[sl]" ) >= 0 ) close_type = 1;
				if ( StringFind( OrderComment(), "[tp]" ) >= 0 ) close_type = 2;
			}
			else
			{	//  : 0 - , 1 -  
				close_type = 0;
				if ( StringFind( OrderComment(), "expiration" ) >= 0 ) close_type = 1;
			}
//      ,    type    close_type
			now_ClosedOrdersArray[type][close_type] ++;
			continue;
		}
		if ( PendingOrderOpened )		//    ,
		{	//     ,     type 
			now_OpenedPendingOrders[type-2] ++;
			continue;
		}
	}
	//+------------------------------------------------------------------+
	//|     -     
	//+------------------------------------------------------------------+
	//      
	if ( !first )
	{		//       
		for ( type = 2; type < 6; type ++ )
		{	//      (   ),   
			if ( now_OpenedPendingOrders[type-2] > 0 )
				SetOpenEvent( type );
		} 
		//      
		for ( type = 0; type < 6; type ++ )
		{
			for ( close_type = 0; close_type < 3; close_type ++ )
			{	//      (  ),   
				if ( now_ClosedOrdersArray[type][close_type] > 0 )
					SetCloseEvent( type, close_type );
			}
		}
	}
	else
	{
		first = false;
	} 	//----        
	ArrayResize( pre_OrdersArray, MathMax( now_OrdersTotal, 1 ) );
	for ( now_CurOrder = 0; now_CurOrder < now_OrdersTotal; now_CurOrder ++ )
	{
		pre_OrdersArray[now_CurOrder][0] = now_OrdersArray[now_CurOrder][0];
		pre_OrdersArray[now_CurOrder][1] = now_OrdersArray[now_CurOrder][1];
	}
	pre_OrdersTotal = now_OrdersTotal;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
void SetOpenEvent( int SetOpenEvent_type )
{
	switch ( SetOpenEvent_type )
	{
		case OP_BUYLIMIT: eventBuyLimitOpened ++; return(0);
		case OP_BUYSTOP: eventBuyStopOpened ++; return(0);
		case OP_SELLLIMIT: eventSellLimitOpened ++; return(0);
		case OP_SELLSTOP: eventSellStopOpened ++; return(0);
	}
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
void SetCloseEvent( int SetCloseEvent_type, int SetCloseEvent_close_type )
{
	switch ( SetCloseEvent_type )
	{
		case OP_BUY:
		{
			if ( SetCloseEvent_close_type == 1 ) eventBuyClosed_SL ++;
			if ( SetCloseEvent_close_type == 2 ) eventBuyClosed_TP ++;
			return(0);
		}
		case OP_SELL:
		{
			if ( SetCloseEvent_close_type == 1 ) eventSellClosed_SL ++;
			if ( SetCloseEvent_close_type == 2 ) eventSellClosed_TP ++;
			return(0);
		}
		case OP_BUYLIMIT:
		{
			if ( SetCloseEvent_close_type == 1 ) eventBuyLimitDeleted_Exp ++;
			return(0);
		}
		case OP_BUYSTOP:
		{
			if ( SetCloseEvent_close_type == 1 ) eventBuyStopDeleted_Exp ++;
			return(0);
		}
		case OP_SELLLIMIT:
		{
			if ( SetCloseEvent_close_type == 1 ) eventSellLimitDeleted_Exp ++;
			return(0);
		}
		case OP_SELLSTOP:
		{
			if ( SetCloseEvent_close_type == 1 ) eventSellStopDeleted_Exp ++;
			return(0);
		}
	}
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------------------+
//|             |
//+------------------------------------------------------------------------------+
bool LastHistoryOrderIsStopLoss()
  {      
   int i=OrdersHistoryTotal()-1;   
   while (true)
     {        
       if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true && 
       (OrderMagicNumber()==MagicNumber) 
       && OrderType()<2)
       {
         if (OrderStopLoss()==OrderClosePrice())
           return(true);
         else  
           return(false);
       }
       i--;
       if (i<0) return(false);  
     }      
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------------------+
//|           |
//+------------------------------------------------------------------------------+
bool LastHistoryOrderIsTakeProfit()
  {      
   int i=OrdersHistoryTotal()-1;   
   while (true)
     {        
       if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true && 
       (OrderMagicNumber()==MagicNumber) 
      && OrderType()<2)
       {
         if (OrderTakeProfit()==OrderClosePrice())
           return(true);
         else  
           return(false);
       }
       i--;
       if (i<0) return(false);  
     }      
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|                 |
//+------------------------------------------------------------------+
double LastProfit(double & lots)
   {
   double res = 0;   lots = 0;
   int tickets = OrdersHistoryTotal();
//----
   if (tickets > 0)
      {
      if (OrderSelect(tickets-1,SELECT_BY_POS,MODE_HISTORY)) 
         { 
         res = OrderProfit();
         lots = OrderLots();
         }
      }
//----
   return(res);
   }
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
string LastOrderComment()
   {
   string res = "";
   int pos = OrdersHistoryTotal();
//----
   if (pos > 0)
      {
      if (OrderSelect(pos-1,SELECT_BY_POS, MODE_HISTORY))  res = OrderComment();
      }
//----
   return(res);
   }
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|   N                               |
//+------------------------------------------------------------------+
double SummLastOrder(int N)
   {
   double res = 0;
   int counter =0,pos = OrdersHistoryTotal()-1;
//----
   for (int i = pos ; i > 0;i--)
      {
      if (OrderSelect(pos-1,SELECT_BY_TICKET))  
         {
         res += OrderProfit();
         counter++;
         if (counter >=N) break;
         }
      }
//----
   return(res);
   } 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string GetLastStringFromFile(string FileName)
  {
//----
  int fname=FileOpen(FileName, FILE_BIN|FILE_READ);
  if (fname>0)
  {
      while (!FileIsEnding(fname)) 
      string  str=GetStringFromFile(fname);   
    FileClose(fname); 
  } 
  else 
  {
      Comment("  ");
  }
//----
   return(str);
  }
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+----------------------------------------------------------------------------+
//|           #13#10           |
//|  :                                                                |
//|    fh -                                                            |
//|                                            |
//+----------------------------------------------------------------------------+
string GetStringFromFile(int& fh)
{
  string str="", s;
  while (!FileIsEnding(fh))
  {
    s=FileReadString(fh, 1);
    int Ch=StringGetChar(s, 0);
    if (Ch!=13 && Ch!=10) str=str+s;
    else return(str);
  }
  return(str);
}
 //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+------------------------------------------------------------------+
//|          |
//|  FileNameOutput                                                  |
//+------------------------------------------------------------------+
bool PrintAllOrdersToFile(string FileNameOutput="")
  {   bool res=false;   int size=OrdersHistoryTotal();
   if (size==0) return;
   string FileName = "OrdersTable.csv";
   if (FileNameOutput=="")   FileName =  WindowExpertName()+ "_" + "OrdersTable.csv";
   else Print(",   FileNameOutput   PrintAllOrdersToFile() =>",FileNameOutput,"<=");
   //----
   int handle=FileOpen(FileName,FILE_WRITE|FILE_CSV);
   if (handle<0)
      {
      Print("    PrintAllOrdersToFile     ",FileNameOutput);
      return(res);
      }
/*
1  #  2   3    4   5    6   
7   8    9   $ 10    
11  12 MagicNumber  13 Comment  14 SL   15 TP  
16 SL   17 TP   18 /
*/  
   FileWrite(handle,"# ; ; ; ;  ;  ;  ;  " ,
   " $;   ; ; MagicNumber; Comment;SL  ; TP  ; SL  ; TP  ; /");
   string outputString;
   for (int i=0;i<size;i++)
      {
      outputString="";
      if (!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
      outputString = outputString + OrderTicket() + ";" + OrderSymbol() +";" 
      + OrderTypeString(OrderType()) + ";" + OrderLots() + ";" +TimeToStr(OrderOpenTime(),TIME_DATE|TIME_SECONDS)+";" ;
      outputString = outputString + OrderOpenPrice() +";" + TimeToStr(OrderCloseTime(),
      TIME_DATE|TIME_SECONDS)+";" + OrderClosePrice() + ";" + OrderProfit() + ";";
      outputString = outputString + OrderProfitPoints(OrderType(),OrderOpenPrice(),OrderClosePrice(),
      OrderSymbol()) + ";" + OrderSwap() + ";" + OrderMagicNumber() + ";";
      outputString = outputString + OrderComment()+ ";" +OrderStopLoss() + ";" +OrderTakeProfit() + ";" + 
      StopLossInPoints(OrderType(),OrderOpenPrice(),OrderStopLoss(),OrderSymbol())+ ";" ;
      outputString = outputString + TakeProfitInPoints(OrderType(),OrderTakeProfit(),
      OrderOpenPrice(),OrderSymbol()) + ";" + WinLossString(OrderType(), OrderOpenPrice(), 
      OrderClosePrice(), OrderSymbol());      
      if (handle>0) FileWrite(handle,outputString);
      }
   if (handle>0) FileClose(handle);
   res=true;
   //----
   return(res);
  }
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|  SL                                            |
//+------------------------------------------------------------------+
int StopLossInPoints(int type, double open, double stop, string sym)
   {   int res = 0;
//----
   if (stop==0) return(0);   
   double point = MarketInfo(sym, MODE_POINT);
   double diff = open - stop;
   if (MathAbs(diff)<point) return(0);   
   int distance = MathRound(diff/point);
   if (type == OP_BUY) res = distance;
   if (type == OP_SELL) res = - distance;   
//----
   return(res);
   }
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|  TP                                            |
//+------------------------------------------------------------------+
int TakeProfitInPoints(int type,double take, double open, string sym)
   {   int res = 0;
//----
   if (take ==0) return(0);
   double point = MarketInfo(sym, MODE_POINT);
   double diff = take - open;
   if (MathAbs(diff)<point) return(0);   
   int distance = MathRound(diff/point);
   if (type == OP_BUY) res = distance;
   if (type == OP_SELL) res = - distance;   
//----
   return(res);
   }
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|  ""  ""                              |
//+------------------------------------------------------------------+
string WinLossString(int type, double open, double close, string sym)
   {   string res = "";
//----
   double point = MarketInfo(sym, MODE_POINT);
   if (MathAbs(close - open)<point) return("Non");
   double profit = close - open;
   if (profit > 0 ) 
      {
      if (type == OP_BUY) res = "Win";
      if (type == OP_SELL) res = "Loss";
      }
   if (profit < 0 ) 
      {
      if (type == OP_BUY) res = "Loss";
      if (type == OP_SELL) res = "Win";
      }
//----
   return(res);   
   }   
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
int OrderProfitPoints(int type, double OpenPrice, double ClosePrice, string sym)
   {   double res = 0 ;
   double point = MarketInfo(sym, MODE_POINT);
   int profit = MathRound((ClosePrice - OpenPrice)/point);
//----
   if (type == OP_BUY) res = profit;
   if (type == OP_SELL) res = - profit;
//----
   return(res);   
   }
  //+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
string OrderTypeString(int type)
   {   string res;
//----
   switch (type)
      {
      case OP_BUY:       res = "buy"; break;
      case OP_SELL:      res = "sell"; break;
      case OP_BUYLIMIT:  res = "buy limit"; break;
      case OP_SELLLIMIT: res = "sell limit"; break;
      case OP_BUYSTOP:   res = "buy stop";  break;
      case OP_SELLSTOP:  res = "sell stop"; break;
      default: res = "balance"; break;      
      }
//----
   return (res);   
   }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//+------------------------------------------------------------------+
//|    /              |
//+------------------------------------------------------------------+
double DepositToDay() {
  int     i, k=OrdersHistoryTotal();  double  d=0;
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderType()>5) {
        if (TimeYear (OrderOpenTime())==Year()  &&
            TimeMonth(OrderOpenTime())==Month() &&
            TimeDay  (OrderOpenTime())==Day())
          d=OrderProfit();
        }
      }
    }
  return(d);
}
//+------------------------------------------------------------------+
//==============================================================================
//+---------    -------------+ 
//==============================================================================
int CloseAllPos(int type)
{
int buy=1; int sell=1;
int i,b=0; 
if(type==0)
  {while(buy==1)
     {buy=0;
      for(i=0;i<OrdersTotal();i++)
       {if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {if(OrderType()==OP_BUY&&OrderSymbol()==Symbol())
          {buy=1;
           if(Block_err_130(1,Tip,OPos,SLpos,TPpos,0,0,0))
            {if(!OrderClose(iTicket,OrderLots(),Closepos,3,White))
             {Alert("    ",ErrorDescription(GetLastError()));
              Print("   ",
              OrderTicket(),". : ",ErrorDescription(GetLastError()));Sleep(1000);
             }
            } 
          }
           else{buy=0;}
        }
         if(buy==0)return(0);
       }
     }
    }
   if(type==1 )
   {while(sell==1)
     {sell=0;
      for(i=0;i<OrdersTotal();i++)
        {if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
          {if(OrderType()==OP_SELL&&OrderSymbol()==Symbol())
           {sell=1;
          if(Block_err_130(1,Tip,OPos,SLpos,TPpos,0,0,0))
            {if(!OrderClose(iTicket,OrderLots(),Closepos,3,White))
             {Alert("    ",ErrorDescription(GetLastError()));
              Print("   ",
              OrderTicket(),". : ",ErrorDescription(GetLastError()));Sleep(1000);
             }
            } 
          }
         }else{sell=0;}
        }  
        if(sell==0)return(0);
      } 
     }
   return(0);
   }
//+------------------------------------------------------------------+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//        
//  type    OP_BUY, OP_SELL, 
// OP_BUYSTOP,OP_SELLSTOP, OP_BUYLIMIT, OP_SELLLIMIT
//      Magic Number,   mg   .
//==============================================================================
bool Close_LastOrder_by_type( int type, int mg = 0)
{
   //    
   datetime time=0;
   int ticket=-1,i;
   for(i=OrdersTotal()-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderType()==type && OrderSymbol()==Symbol() && OrderMagicNumber()==mg)
         {
            if(OrderOpenTime()>time)
            {
               time=OrderOpenTime();
               ticket=OrderTicket();
            }
         }
      }
   }
   if(OrderTicket()!=ticket)OrderSelect(ticket,SELECT_BY_TICKET);
   if(OrderType()<=1)return(OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3));
           if(Block_err_130(1,Tip,OPos,SLpos,TPpos,0,0,0))
            {if(!OrderClose(iTicket,OrderLots(),Closepos,3,White))
             {Alert("    ",ErrorDescription(GetLastError()));
              Print("   ",
              OrderTicket(),". : ",ErrorDescription(GetLastError()));Sleep(1000);
             }
            } 
      else return(OrderDelete(OrderTicket()));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//==============================================================================
//   OP_BUYSTOP  OP_SELLSTOP,
// type -  
// 1 - BUYSTOP,
// 2 - SELLSTOP,
// open -  ,
// stop -  . 
//==============================================================================
int ySendStopOrder(int type,double open,double stop)
{
   double op,sl,tp;
   int err;
   if(type==1)
   {
      op=open;      sl=stop;
      err=OrderSend(Symbol(),OP_BUYSTOP,Lots,NormalizeDouble(op,Digits),3,NormalizeDouble(sl,Digits),0,WindowExpertName()+Period(),MagicNumber,0,Red);  
      if(err<0)
      {
         Print("OrderSend()-   OP_BUYSTOP.  op "+op+" sl "+sl+" tp "+tp+" "+GetLastError());
         return(-1);
      }
   }
   if(type==2)
   {
      op=open;
      sl=stop;
      err=OrderSend(Symbol(),OP_SELLSTOP,Lots,NormalizeDouble(op,Digits),3,NormalizeDouble(sl,Digits),0,WindowExpertName()+Period(),MagicNumber,0,Red);
      if(err<0)
         {
            Print("OrderSend()-   OP_SELLSTOP.  op "+op+" sl "+sl+" tp "+tp+" "+GetLastError());
            return(-1);
         }
   }
   return(0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//     BUYSTOP SELLSTOP 
int yChStopPos(int type) 
{
   int i;
   for( i=1; i<=OrdersTotal(); i++)         
   {
      if(OrderSelect(i-1,SELECT_BY_POS)==true) 
         {                                   
           if(OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol() && type==1){return(1);}
           if(OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol() && type==2){return(1);}
         }
    }   
return(0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//==============================================================================
//    SELLSTOP  BUYSTOP  type
//==============================================================================
int yDeleteOrder(int type)
{
   for( int i=1; i<=OrdersTotal(); i++)          
      {
         if(OrderSelect(i-1,SELECT_BY_POS)==true) 
            {                                       
               if(OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol() && type==2)
                  {
                     OrderDelete(OrderTicket()); 
                  }//if
  
               if(OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol() && type==1)
                  {
                     OrderDelete(OrderTicket()); 
                  }//if
            }//if
      }
   return(0);
}
//==============================================================================
// ClosePosBySelect "    "
//==============================================================================
void ClosePosBySelect() {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), err, it;
  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=MarketInfo(OrderSymbol(), MODE_ASK);
      pb=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pb; clClose=clModifyBuy;
      } else {
        pp=pa; clClose=clModifySell;
      }
      ll=OrderLots();
      pp=NormalizeDouble(pp, dg);
      fc=OrderClose(OrderTicket(), ll, pp, Slippage, clClose);
      if (fc) {
         break;
      } else {
        err=GetLastError();
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Print("Error(",err,") Close ",GetNameOP(OrderType())," ",
              ErrorDescription(err),", try ",it);
        Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
        Sleep(1000*5);
           if(Block_err_130(1,Tip,OPos,SLpos,TPpos,0,0,0))
            {if(!OrderClose(iTicket,OrderLots(),Closepos,3,White))
             {Alert("    ",ErrorDescription(GetLastError()));
              Print("   ",
              OrderTicket(),". : ",ErrorDescription(GetLastError()));Sleep(1000);
             }
            } 
      }
    }
  } else Print("  . Close ",GetNameOP(OrderType()));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//==============================================================================
// :   ,         
//:
//sy -   ("" -  ,NULL -  )
//op -  (-1 -  )
//mn - MagicNumber (-1 -  )
//pr - /
void ClosePosBySizeLossInCurrency(string sy="", int op=-1, int mn=-1, double pr=0) {
  int i, k=OrdersTotal();
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (OrderProfit()+OrderSwap()<-MathAbs(pr)) ClosePosBySelect();
          }
        }
      }
    }
  }
}
//==============================================================================
//  ,      
//  
//=========================================================================
// sy -   ("" -  , NULL -  )
// op -      (-1   -  )
// mn - MagicNumber  (-1   -  )
// pr - 
void ClosePosBySizeProfitInCurrency(string sy="", int op=-1, int mn=-1, double pr=0) {
  int i, k=OrdersTotal();
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (OrderProfit()+OrderSwap()>pr) ClosePosBySelect();
          }
        }
      }
    }
  }
}
//==============================================================================
//    
//==============================================================================
//  sy -     (""   -  , NULL -  )
//  op -                    (-1   -  )
//  mn - MagicNumber                (-1   -  )
void ClosePositions(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) ClosePosBySelect();
        }
      }
    }
  }
}
//==============================================================================
//+----------------------------------------------------------------------------+
//|   :                             |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
double GetAmountLotFromOpenPos(string sy="", int op=-1, int mn=-1) {
  double l=0;  int    i, k=OrdersTotal();
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              l+=OrderLots();
            }
          }
        }
      }
    }
  }
  return(l);
}
//+===================================================================================+
//|***********************************************************************************|
//| :                                                            |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|      ErrorDescription()          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string ErrorDescription (int error_code)
{
    string error_string;
//---- 
    switch (error_code)
    {
         //---- codes returned from trade server
         case 0:      return (" !!!");
         case 1:      error_string = "       ."; break;
         case 2:      error_string = " .        ."; break;
         case 3:      error_string = "     ."; break;
         case 4:      error_string = "  ."; break;
         case 5:      error_string = "   ."; break;
         case 6:      error_string = "    ."; break;
         case 7:      error_string = " ."; break;
         case 8:      error_string = "  ."; break;
         case 9:      error_string = "    ."; break;
         case 64:     error_string = " .      ."; break;
         case 65:     error_string = "  ."; break;
         case 128:    error_string = "    ."; break;
         case 129:    error_string = "  bid  ask, ,  ."; break;
         case 130:    error_string = "           (     )."; break;
         case 131:    error_string = " ,    ."; break;
         case 132:    error_string = " ."; break;
         case 133:    error_string = " ."; break;
         case 134:    error_string = "    ."; break;
         case 135:    error_string = " ."; break;
         case 136:    error_string = " ."; break;
         case 137:    error_string = " ."; break;
         case 138:    error_string = "  ,   bid  ask."; break;
         case 139:    error_string = "    ."; break;
         case 140:    error_string = "  .   SELL ."; break;
         case 141:    error_string = "  ."; break;
         case 142:    error_string = "   ."; break;
         case 143:    error_string = "    ."; break;
         case 144:    error_string = "       ."; break;
         case 145:    error_string = " ,          -   ."; break;
         case 146:    error_string = "  ."; break;
         case 147:    error_string = "     ."; break;
         case 148:    error_string = "      ,  ."; break;
         case 149:    error_string = "        ,   ."; break;
         case 4000:   return ("");
         case 4001:   error_string = "  ."; break;
         case 4002:   error_string = "  -  ."; break;
         case 4003:   error_string = "    ."; break;
         case 4004:   error_string = "    ."; break;
         case 4005:   error_string = "      ."; break;
         case 4006:   error_string = "    ."; break;
         case 4007:   error_string = "    ."; break;
         case 4008:   error_string = " ."; break;
         case 4009:   error_string = "   ."; break;
         case 4010:   error_string = "    ."; break;
         case 4011:   error_string = "  ."; break;
         case 4012:   error_string = "    ."; break;
         case 4013:   error_string = "  ."; break;
         case 4014:   error_string = " ."; break;
         case 4015:   error_string = " ."; break;
         case 4016:   error_string = " ."; break;
         case 4017:   error_string = " DLL  ."; break;
         case 4018:   error_string = "  ."; break;
         case 4019:   error_string = "  ."; break;
         case 4020:   error_string = "     ."; break;
         case 4021:   error_string = "   ,   ."; break;
         case 4022:   error_string = " ."; break;
         case 4050:   error_string = "   ."; break;
         case 4051:   error_string = "   ."; break;
         case 4052:   error_string = "   ."; break;
         case 4053:   error_string = " ."; break;
         case 4054:   error_string = "  -."; break;
         case 4055:   error_string = "  ."; break;
         case 4056:   error_string = " ."; break;
         case 4057:   error_string = "   ."; break;
         case 4058:   error_string = "   ."; break;
         case 4059:   error_string = "     ."; break;
         case 4060:   error_string = "  ."; break;
         case 4061:   error_string = "  ."; break;
         case 4062:   error_string = "   string."; break;
         case 4063:   error_string = "   integer."; break;
         case 4064:   error_string = "   double."; break;
         case 4065:   error_string = "    ."; break;
         case 4066:   error_string = "     ."; break;
         case 4067:   error_string = "    ."; break;
         case 4099:   error_string = " ."; break;
         case 4100:   error_string = "    ."; break;
         case 4101:   error_string = "  ."; break;
         case 4102:   error_string = "   ."; break;
         case 4103:   error_string = "  ."; break;
         case 4104:   error_string = "    ."; break;
         case 4105:   error_string = "    ."; break;
         case 4106:   error_string = " ."; break;
         case 4107:   error_string = "     ."; break;
         case 4108:   error_string = "  ."; break;
         case 4109:   error_string = "  .         ."; break;
         case 4110:   error_string = "   .    ."; break;
         case 4111:   error_string = "   .    ."; break;
         case 4200:   error_string = "  ."; break;
         case 4201:   error_string = "   ."; break;
         case 4202:   error_string = "  ."; break;
         case 4203:   error_string = "  ."; break;
         case 4204:   error_string = "  ."; break;
         case 4205:   error_string = "  ."; break;
         case 4206:   error_string = "   ."; break;
         case 4207:   error_string = "    ."; break;
    }  
//---- 
    return (error_string);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGetLastError (string& Comm_Error, string Com = "")
{
    int err = GetLastError();
    string ls_err;
//---- 
    if (err > 0 && err != 4202 && err != 4099)
    {
        ls_err = StringConcatenate (Com, ":   ", err, ": ", ErrorDescription (err));
        Print (ls_err);
        Comm_Error = ls_err;
    }
//---- 
    return (err);
}
//+===================================================================================+
bool Block_err_130(int M,int TypeOrder,double OP,double StopLoss,double TakeProfit,
                     double NewOpenPrice,double NewStopLoss,double NewTakeProfit) 
{int Mode=0;int Type=-1;int J=0; 
 double OpenPrice=0;double TP=0;double SL=0;double OPnew=0;double TPnew=0;double SLnew=0;
 double point=MarketInfo(Symbol(),MODE_POINT);
 double StopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL)*point;
 double FreezeLevel=MarketInfo(Symbol(),MODE_FREEZELEVEL)*point;
 Mode=M;Type=TypeOrder;J=Mode*10+Type;
 if(Mode==1){OpenPrice=OP;TP=TakeProfit;SL=StopLoss;}
 if(Mode==2){OPnew=NewOpenPrice;TPnew=NewTakeProfit;SLnew=NewStopLoss;}     
 if(Mode==3){OpenPrice=OP;TP=TakeProfit;SL=StopLoss;OPnew=NewOpenPrice;
             TPnew=NewTakeProfit;SLnew=NewStopLoss;} 
 RefreshRates();           
switch(J){ //----/   " I"/
case 10:// OP_BUY:Mode==1,Type==0
 if((Bid-SL>FreezeLevel||SL==0)&&(TP-Bid>FreezeLevel||TP==0)&&Mode==1)return(true);break;
case 11:// OP_SELL:Mode==1,Type==1
 if((SL-Ask>FreezeLevel||SL==0)&&(Ask-TP>FreezeLevel||TP==0)&&Mode==1)return(true);break;
case 12:// BuyLimit:Mode==1,Type==2
 if((Ask-OpenPrice>FreezeLevel)&&(StopLevel<=OpenPrice-SL||SL==0)&& 
    (StopLevel<=TP-OpenPrice||TP==0)&&Mode==1)return(true);break;
case 13:// SellLimit:Mode==1,Type==3
 if((OpenPrice-Bid>FreezeLevel)&&(StopLevel<=SL-OpenPrice||SL==0)&& 
    (StopLevel<=OpenPrice-TP||TP==0)&&Mode==1)return(true);break;
case 14:// BuyStop:Mode==1,Type==4
 if((OpenPrice-Ask>FreezeLevel)&&(StopLevel<=OpenPrice-SL||SL==0)&& 
    (StopLevel<=TP-OpenPrice||TP==0)&&Mode==1)return(true);break;
case 15:// SellStop:Mode==1,Type==5
 if((Bid-OpenPrice>FreezeLevel)&&(StopLevel<=SL-OpenPrice||SL==0)&& 
    (StopLevel<=OpenPrice-TP||TP==0)&&Mode==1)return(true);break;
       //----   " II"/ 
case 20:// OP_BUY:Mode==2,Type==0
 if((StopLevel<=Bid-SLnew||SLnew==0)&&(StopLevel<=TPnew-Bid||TPnew==0))return(true);break; 
case 21:// OP_SELL:Mode==2,Type==1
 if((StopLevel<=SLnew-Ask||SLnew==0)&&(StopLevel<=Ask-TPnew||TPnew==0))return(true);break;
case 22:// BuyLimit:Mode==2,Type==2
 if((StopLevel<=Ask-OPnew)&&(StopLevel<=OPnew-SLnew||SLnew==0)&& 
  (StopLevel<=TPnew-OPnew||TPnew==0)&&Mode==2)return(true);break;  
case 23:// SellLimit:Mode==2,Type==3
 if((StopLevel<=OPnew-Bid)&&(StopLevel<=SLnew-OPnew||SLnew==0)&& 
  (StopLevel<=OPnew-TPnew||TPnew==0)&&Mode==2)return(true);break;
case 24:// BuyStop:Mode==2,Type==4
 if((StopLevel<=OPnew-Ask)&&(StopLevel<=OPnew-SLnew||SLnew==0)&& 
  (StopLevel<=TPnew-OPnew||TPnew==0)&&Mode==2) return(true);break;
case 25:// SellStop:Mode==2,Type==5
 if((StopLevel<=Bid-OPnew)&&(StopLevel<=SLnew-OPnew||SLnew==0)&& 
  (StopLevel<=OPnew-TPnew||TPnew==0)&&Mode==2)return(true);break;
case 30:// Buy  
 if((Bid-SL>FreezeLevel||SL==0)&&(TP-Bid>FreezeLevel||TP==0))
  {if((StopLevel<=Bid-SLnew||SLnew==0)&&(StopLevel<=TPnew-Bid||TPnew==0))return(true);}break; 
case 31:// Sell   
 if((SL-Ask>FreezeLevel||SL==0)&&(Ask-TP>FreezeLevel||TP==0)) 
  {if((StopLevel<=SLnew-Ask||SLnew==0)&&(StopLevel<=Ask-TPnew||TPnew==0))return(true);}break;
case 32:// BuyLimit 
 if((Ask-OpenPrice>FreezeLevel)&&(StopLevel<=OpenPrice-SL||SL==0)&& 
   (StopLevel<=TP-OpenPrice||TP==0))
  {if((StopLevel<=Ask-OPnew)&&(StopLevel<=OPnew-SLnew||SLnew==0)&& 
    (StopLevel<=TPnew-OPnew||TPnew==0))return(true);}break;                 
case 33:// SellLimit 
 if((OpenPrice-Bid>FreezeLevel)&&(StopLevel<=SL-OpenPrice||SL==0)&& 
   (StopLevel<=OpenPrice-TP||TP==0)) 
  {if((StopLevel<=OPnew-Bid)&&(StopLevel<=SLnew-OPnew||SLnew==0)&& 
    (StopLevel<=OPnew-TPnew||TPnew==0))return(true);}break;   
case 34:// BuyStop 
 if((OpenPrice-Ask>FreezeLevel)&&(StopLevel<=OpenPrice-SL||SL==0)&& 
   (StopLevel<=TP-OpenPrice||TP==0))  
  {if((StopLevel<=OPnew-Ask)&&(StopLevel<=OPnew-SLnew||SLnew==0)&& 
    (StopLevel<=TPnew-OPnew||TPnew==0))return(true);}break; 
case 35:// SellStop              
 if((Bid-OpenPrice>FreezeLevel)&&(StopLevel<=SL-OpenPrice||SL==0)&& 
   (StopLevel<=OpenPrice-TP||TP==0)) 
  {if((StopLevel<=Bid-OPnew)&&(StopLevel<=SLnew-OPnew||SLnew==0)&& 
    (StopLevel<=OPnew-TPnew||TPnew==0))return(true);}break;}return(0);}
//+X================================================================X+
//+X================================================================X+
//+~~~~~~~~~~~~~~~~~~=========###############=========~~~~~~~~~~~~~~~+
 